<!-- right hand side property editor pane -->
<template>
    <div class="container">
        <!-- run mode         -->
        <div class="container" v-show="viewData.running">
            Running!
        </div>
         <!-- Project settings, when no items selected -->
        <div v-show="!viewData.running && !anyItemsSelected" class="container"> 
            <v-list dense expand width="100%" class="overflow-y-auto" style="max-height: 100%">
                <v-list-group dense v-for="(propertyGroup, index) in projectData.properties" v-bind:key="index" value="true">
                    <template v-slot:activator>
                        <v-list-item-title>{{ propertyGroup.name }}</v-list-item-title>
                    </template>
                    <v-list-item dense v-for="(prop, index) in propertyGroup.props" v-bind:key="index">
                        <v-list-item-content>
                            <NumberEditor  v-if="prop.type==NUMBER" :label="prop.name" v-model="prop.value" @input="projectDataChanged"></NumberEditor>
                            <SignalEditor  v-else-if="prop.type==SIGNAL" :label="prop.name" v-model="prop.value" @input="projectDataChanged"></SignalEditor>
                            <TextEditor    v-else-if="prop.type==STRING" :label="prop.name" v-model="prop.value" @input="projectDataChanged"></TextEditor>
                            <HAlignEditor  v-else-if="prop.type==HALIGN" v-model="prop.value" @input="projectDataChanged"></HAlignEditor>
                            <VAlignEditor  v-else-if="prop.type==VALIGN" v-model="prop.value" @input="projectDataChanged"></VAlignEditor>
                            <ColorEditor   v-else-if="prop.type==COLOR" :label="prop.name" v-model="prop.value" @input="projectDataChanged"></ColorEditor>
                            <BooleanEditor v-else-if="prop.type==BOOLEAN" :label="prop.name" v-model="prop.value" @input="projectDataChanged"></BooleanEditor>
                            <SelectionEditor v-else-if="prop.type==SELECTION" :label="prop.name" v-model="prop.value" @input="projectDataChanged"></SelectionEditor>                        
                            <div v-else>
                                ERROR: no editor found for type {{ prop.type }}!
                                {{ prop.name}} = {{ prop.value }}
                            </div>    
                        </v-list-item-content>
                    </v-list-item>   
                </v-list-group>   
            </v-list>
            <ToolBox id="toolbox" v-show="!viewData.running || 1"></ToolBox>

        </div>    
        <!-- Item properties (when item(s) selected) -->
        <div v-show="!viewData.running && anyItemsSelected" class="container">  
            <v-list dense expand width="100%" class="overflow-y-auto" style="max-height: 100%">
                <v-list-group dense v-for="(propertyGroup, index) in editedItem.properties" v-bind:key="index" value="true">
                    <template v-slot:activator>
                        <v-list-item-title>{{ propertyGroup.name }}</v-list-item-title>
                    </template>
                    <v-list-item dense v-for="(prop, index) in propertyGroup.props" v-bind:key="index">
                        <v-list-item-content>
                            <NumberEditor  v-if="prop.type==NUMBER" :label="prop.name" v-model="prop.value" @input="redrawItem"></NumberEditor>
                            <TextEditor    v-else-if="prop.type==STRING" :label="prop.name" v-model="prop.value" @input="redrawItem"></TextEditor>
                            <SignalEditor  v-else-if="prop.type==SIGNAL" :label="prop.name" v-model="prop.value" @input="redrawItem"></SignalEditor>
                            <HAlignEditor  v-else-if="prop.type==HALIGN" v-model="prop.value" @input="redrawItem"></HAlignEditor>
                            <VAlignEditor  v-else-if="prop.type==VALIGN" v-model="prop.value" @input="redrawItem"></VAlignEditor>
                            <ColorEditor   v-else-if="prop.type==COLOR" :label="prop.name" v-model="prop.value" @input="redrawItem"></ColorEditor>
                            <BooleanEditor v-else-if="prop.type==BOOLEAN" :label="prop.name" v-model="prop.value" @input="redrawItem"></BooleanEditor>
                            <EnumEditor    v-else-if="prop.type==ENUM" v-model="prop.value" @input="redrawItem"></EnumEditor>
                            <SelectionEditor v-else-if="prop.type==SELECTION" :label="prop.name" v-model="prop.value" @input="redrawItem"></SelectionEditor>                        
                            <div v-else>
                                ERROR: no editor found for type {{ prop.type }}!
                                {{ prop.name}} = {{ prop.value }}
                            </div>    
                        </v-list-item-content>
                    </v-list-item>   
                </v-list-group>       
            </v-list>
        </div>   
    </div>   
</template>

<script lang="ts">
import Vue from 'vue';
import NumberEditor    from '@/components/NumberEditor.vue';
import TextEditor      from '@/components/TextEditor.vue';
import SignalEditor    from '@/components/SignalEditor.vue';
import HAlignEditor    from '@/components/HAlignEditor.vue';
import VAlignEditor    from '@/components/VAlignEditor.vue';
import ColorEditor     from '@/components/ColorEditor.vue';
import BooleanEditor   from '@/components/BooleanEditor.vue';
import SelectionEditor from '@/components/SelectionEditor.vue';
import EnumEditor      from '@/components/EnumEditor.vue';
import ToolBox         from '@/components/ToolBox.vue';
import { ItemData, PropertyType } from '@/ItemData';
import { viewData }    from '@/ViewData';     // viewData is reactive
import { projectData } from '@/ProjectData';  // projectData is reactive

export default Vue.extend({
    props: {
        ItemData: Object
    },

    data () {
        return {
            viewData: viewData,        // global 'store'            
            projectData: projectData,  // global 'store'            
            // export PropertyType enum's to template
            NUMBER: PropertyType.NUMBER,
            STRING: PropertyType.STRING,
            SIGNAL: PropertyType.SIGNAL,
            HALIGN: PropertyType.HALIGN,
            VALIGN: PropertyType.VALIGN,
            COLOR: PropertyType.COLOR,
            BOOLEAN: PropertyType.BOOLEAN,
            ENUM: PropertyType.ENUM,
            SELECTION: PropertyType.SELECTION
        }
    },

    computed: {
        anyItemsSelected(): boolean {
            for (const item of this.viewData.items) {                
                if (item.selected) {
                    return true;
                }
            }
            return false;
        },
        editedItem(): ItemData { 
            if (this.viewData.items.length > 0) {  // dont't bother if no items
                for (const item of this.viewData.items) {                
                    if (item.selected) {
                        return item;
                    }
                }
            }
            return {} as ItemData;
        },

        itemCount(): number {
            return this.viewData.count();
        }
    },

    methods: {        
        projectDataChanged(): void {
            projectData.applyChanges();
        },

        redrawItem(): void {
            if (this.viewData.pushUndoIfChanged()) // If state changes then
                this.editedItem.graphics?.update();     // update graphics.
            viewData.redraw();
        }
    },

    components: { NumberEditor, 
                  TextEditor, 
                  SignalEditor, 
                  HAlignEditor, 
                  VAlignEditor, 
                  ColorEditor, 
                  BooleanEditor, 
                  SelectionEditor, 
                  EnumEditor, 
                  ToolBox }
});
</script>

<style scoped>
.container {
    color: white;
    margin: 0px;
    padding: 0px;
    height: 100%;
}
</style>
